(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react-emotion'), require('prop-types'), require('lodash.isinteger')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react-emotion', 'prop-types', 'lodash.isinteger'], factory) :
	(factory((global['emotion-react-flexbox-grid'] = {}),global.styled,global.PropTypes,global._.isInteger));
}(this, (function (exports,styled,PropTypes,isInteger) { 'use strict';

var styled__default = 'default' in styled ? styled['default'] : styled;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
isInteger = isInteger && isInteger.hasOwnProperty('default') ? isInteger['default'] : isInteger;

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



























var taggedTemplateLiteralLoose = function (strings, raw) {
  strings.raw = raw;
  return strings;
};

var THEME_CONF = 'flexboxgrid';
var BASE_CONF = {
  gridSize: 12,
  gutterWidth: 1,
  outerMargin: 2,
  mediaQuery: 'only screen',
  container: {
    sm: 46,
    md: 61,
    lg: 76
  },
  breakpoints: {
    xs: 0,
    sm: 48,
    md: 64,
    lg: 75
  }
};

var _ref = '@media ';
var _ref2 = '{';
var _ref3 = ';}';
function makeMedia(media) {
  return function () {
    return (/*#__PURE__*/styled.css(_ref, media, _ref2, /*#__PURE__*/styled.css.apply(undefined, arguments), _ref3)
    );
  };
}

var configCache = [];
var makeCacheId = function makeCacheId() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return JSON.stringify(props.theme && props.theme[THEME_CONF] || {});
};
var resolveConfig = function resolveConfig() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var themeConf = props.theme && props.theme[THEME_CONF] || {};

  var conf = _extends({}, BASE_CONF, themeConf, {
    container: _extends({}, BASE_CONF.container, themeConf.container),
    breakpoints: _extends({}, BASE_CONF.breakpoints, themeConf.breakpoints)
  });

  conf.media = Object.keys(conf.breakpoints).reduce(function (media, breakpoint) {
    var breakpointWidth = conf.breakpoints[breakpoint];
    media[breakpoint] = makeMedia([conf.mediaQuery, breakpoint !== 0 && '(min-width: ' + breakpointWidth + 'em)'].filter(Boolean).join(' and '));
    return media;
  }, {});

  return conf;
};

var DIMENSION_NAMES = ['xs', 'sm', 'md', 'lg'];

function config() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var cacheId = makeCacheId(props);
  if (configCache[0] === cacheId) {
    return configCache[1];
  }

  var conf = resolveConfig(props);

  configCache[0] = cacheId;
  configCache[1] = conf;

  return conf;
}

var _templateObject = taggedTemplateLiteralLoose(['\n        width: ', 'rem;\n      '], ['\n        width: ', 'rem;\n      ']);

var _ref$1 = 'padding-right:';
var _ref2$1 = ';padding-left:';
var _ref3$1 = ';';
var _ref4 = ';';
var Grid = /*#__PURE__*/styled__default('div', {
  target: 'endb7rq0'
})('margin-right:auto;margin-left:auto;', function (gridProps) {
  if (gridProps.fluid) {
    return (/*#__PURE__*/styled.css(_ref$1, function (props) {
        return config(props).outerMargin + 'rem';
      }, _ref2$1, function (props) {
        return config(props).outerMargin + 'rem';
      }, _ref3$1)
    );
  }
  return (/*#__PURE__*/styled.css(DIMENSION_NAMES.map(function (t) {
      return config(gridProps).container[t] && config(gridProps).media[t](_templateObject, function (props) {
        return config(props).container[t];
      });
    }), _ref4)
  );
}, ';');

Grid.displayName = 'Grid';

Grid.propTypes = {
  fluid: PropTypes.bool,
  children: PropTypes.node
};

var _templateObject$1 = taggedTemplateLiteralLoose(['\n    justify-content: flex-start;\n    text-align: start;\n  '], ['\n    justify-content: flex-start;\n    text-align: start;\n  ']);
var _templateObject2 = taggedTemplateLiteralLoose(['\n    justify-content: center;\n    text-align: center;\n  '], ['\n    justify-content: center;\n    text-align: center;\n  ']);
var _templateObject3 = taggedTemplateLiteralLoose(['\n    justify-content: flex-end;\n    text-align: end;\n  '], ['\n    justify-content: flex-end;\n    text-align: end;\n  ']);
var _templateObject4 = taggedTemplateLiteralLoose(['\n    align-items: flex-start;\n  '], ['\n    align-items: flex-start;\n  ']);
var _templateObject5 = taggedTemplateLiteralLoose(['\n    align-items: center;\n  '], ['\n    align-items: center;\n  ']);
var _templateObject6 = taggedTemplateLiteralLoose(['\n    align-items: flex-end;\n  '], ['\n    align-items: flex-end;\n  ']);
var _templateObject7 = taggedTemplateLiteralLoose(['\n    justify-content: space-around;\n  '], ['\n    justify-content: space-around;\n  ']);
var _templateObject8 = taggedTemplateLiteralLoose(['\n    justify-content: space-between;\n  '], ['\n    justify-content: space-between;\n  ']);
var _templateObject9 = taggedTemplateLiteralLoose(['\n    order: -1;\n  '], ['\n    order: -1;\n  ']);
var _templateObject10 = taggedTemplateLiteralLoose(['\n    order: 1;\n  '], ['\n    order: 1;\n  ']);

var ModificatorType = PropTypes.oneOf(DIMENSION_NAMES);

var Row = /*#__PURE__*/styled__default('div', {
  target: 'egakbg90'
})('box-sizing:border-box;display:flex;flex:0 1 auto;flex-direction:row;flex-wrap:wrap;margin-right:', function (p) {
  return config(p).gutterWidth / 2 * -1;
}, 'rem;margin-left:', function (p) {
  return config(p).gutterWidth / 2 * -1;
}, 'rem;', function (p) {
  return p.reverse && '\n    flex-direction: row-reverse;\n  ';
}, '\n\n  ', function (p) {
  return p.start && config(p).media[p.start](_templateObject$1);
}, '\n\n  ', function (p) {
  return p.center && config(p).media[p.center](_templateObject2);
}, '\n\n  ', function (p) {
  return p.end && config(p).media[p.end](_templateObject3);
}, '\n\n  ', function (p) {
  return p.top && config(p).media[p.top](_templateObject4);
}, '\n\n  ', function (p) {
  return p.middle && config(p).media[p.middle](_templateObject5);
}, '\n\n  ', function (p) {
  return p.bottom && config(p).media[p.bottom](_templateObject6);
}, '\n\n  ', function (p) {
  return p.around && config(p).media[p.around](_templateObject7);
}, '\n\n  ', function (p) {
  return p.between && config(p).media[p.between](_templateObject8);
}, '\n\n  ', function (p) {
  return p.first && config(p).media[p.first](_templateObject9);
}, '\n\n  ', function (p) {
  return p.last && config(p).media[p.last](_templateObject10);
});

Row.displayName = 'Row';

Row.propTypes = {
  reverse: PropTypes.bool,
  start: ModificatorType,
  center: ModificatorType,
  end: ModificatorType,
  top: ModificatorType,
  middle: ModificatorType,
  bottom: ModificatorType,
  around: ModificatorType,
  between: ModificatorType,
  first: ModificatorType,
  last: ModificatorType,
  children: PropTypes.node
};

var _templateObject$2 = taggedTemplateLiteralLoose(['', ''], ['', '']);
var _templateObject2$1 = taggedTemplateLiteralLoose(['\n        margin-left: ', '%;\n      '], ['\n        margin-left: ', '%;\n      ']);

var ModificatorType$1 = PropTypes.oneOfType([PropTypes.number, PropTypes.bool]);

var offsetProps = DIMENSION_NAMES.map(function (dimension) {
  return dimension + 'Offset';
});
var DimensionPropTypes = DIMENSION_NAMES.reduce(function (propTypes, dimension) {
  propTypes[dimension] = ModificatorType$1;
  propTypes[dimension + 'Offset'] = PropTypes.number;
  return propTypes;
}, {});

var Col = /*#__PURE__*/styled__default('div', {
  target: 'e15h0eyx0'
})('box-sizing:border-box;flex:0 0 auto;padding-right:', function (p) {
  return config(p).gutterWidth / 2;
}, 'rem;padding-left:', function (p) {
  return config(p).gutterWidth / 2;
}, 'rem;', function (p) {
  return p.reverse && '\n    flex-direction: column-reverse;\n  ';
}, '\n\n  ', function (p) {
  return Object.keys(p).filter(function (k) {
    return DIMENSION_NAMES.indexOf(k) >= 0;
  }).sort(function (k1, k2) {
    return DIMENSION_NAMES.indexOf(k1) - DIMENSION_NAMES.indexOf(k2);
  }).map(function (k) {
    // default is Hide element
    var cssValue = 'display: none;';
    if (isInteger(p[k])) {
      cssValue = '\n            flex-basis: ' + 100 / config(p).gridSize * p[k] + '%;\n            max-width: ' + 100 / config(p).gridSize * p[k] + '%;\n            display: block;\n          ';
    } else if (p[k]) {
      // Auto-width
      cssValue = '\n            flex-grow: 1;\n            flex-basis: 0;\n            max-width: 100%;\n            display: block;\n          ';
    }
    return config(p).media[k](_templateObject$2, cssValue);
  });
}, '\n\n  ', function (p) {
  return Object.keys(p).filter(function (k) {
    return offsetProps.indexOf(k) >= 0;
  }).map(function (k) {
    return config(p).media[k.replace(/Offset$/, '')](_templateObject2$1, 100 / config(p).gridSize * p[k]);
  });
});

Col.displayName = 'Col';

Col.propTypes = _extends({}, DimensionPropTypes, {
  reverse: PropTypes.bool,
  children: PropTypes.node
});

exports.Grid = Grid;
exports.Row = Row;
exports.Col = Col;
exports.BASE_CONF = BASE_CONF;

Object.defineProperty(exports, '__esModule', { value: true });

})));
